Ordinarily, Git garbage collects all orphaned commits and deletes them after a period of time, under the assumption that you're not using them anymore, and they're just taking up space.

In the branchless workflow, this behavior is suppressed. Orphaned commits are not allowed to be garbage collected by Git unless they are also hidden (see "Visibility"). That is to say, Git won't garbage collect commits as long as they're still visible in the smartlog, even if they don't have a branch attached to them.

To emphasize, `git-branchless` only ever causes *fewer* commits to be garbage-collected than normal.

The practical impact is that old hidden commits may be garbage-collected by Git after some time. You won't be able to access them, even with `git undo`.