<!--ts-->


<!-- Added by: runner, at: (timestamp removed) -->

<!--te-->

## Description

*Available since v0.8.0.*

The `git branchless difftool` subcommand exposes an interactive interface to view diffs. You can integrate it into Git by setting it as a [difftool](https://git-scm.com/docs/git-difftool) or [mergetool](https://git-scm.com/docs/git-mergetool). Here's what it looks like:

<img width="1242" alt="Screenshot 2023-08-31 at 16 05 26" src="https://github.com/arxanas/git-branchless/assets/454057/197eb086-4ddf-4388-95d6-95ed072c04f6">

## Usage

Example configuration for your `.gitconfig`:

```ini
[difftool "branchless"]
  cmd = git-branchless difftool --read-only --dir-diff $LOCAL $REMOTE

[mergetool "branchless"]
  cmd = git-branchless difftool $LOCAL $REMOTE --base $BASE --output $MERGED
```

Then you can invoke it instead of `git diff` via a command like this (you may want to create a more usable alias for yourself):

```sh
$ git difftool --tool 'branchless' --dir-diff HEAD~
```