<!--ts-->


<!-- Added by: runner, at: (timestamp removed) -->

<!--te-->

## Compatible Git versions

You can check your installed version of Git by running `git version`.

The following versions of Git have been tested with `git-branchless`:

| Git version | Compatible? | Supports undo? | Notes |
| :---: | :---: | :---: | --- |
| ≤ 2.17 | ❌ | ❌ | `git move` invocations may fail.<br />`label`/`reset`/`merge` commands for `git rebase -i` [not implemented until Git v2.18](https://git-scm.com/docs/git-rebase/2.18.0). |
| 2.18–2.23 | ? | ? | Untested, but may still work. |
| 2.24–2.27 | ✅ | ❌ | |
| 2.28 | ❌ | ❌ | Bug related to `reference-transaction` support.<br />No intention to fix at this time; upgrade your Git version.<br />File an issue if you really need Git v2.28. |
| 2.29 | ✅ | ✅ | First version with `git undo` support. |
| 2.30 | ✅ | ✅ | |
| 2.31 | ✅ | ✅ | Git v2.31+ are supported in `git-branchless` v0.3.2 or later. |
| 2.32–2.37 | ✅ | ✅ |  |
| [master](https://github.com/git/git/commits/master) | | | See latest test run:<br />[![Linux (Git master)](https://github.com/arxanas/git-branchless/actions/workflows/linux-git-devel.yml/badge.svg)](https://github.com/arxanas/git-branchless/actions/workflows/linux-git-devel.yml) |

## Upgrading your version of Git

Upgrading Git depends on your operating system. Below are instructions for a few popular operating systems.

### Windows (Git for Windows)

Manual Download: [Git for Windows](https://gitforwindows.org/)

Using [Chocolatey](https://chocolatey.org/) (as Admin!):
```
choco upgrade git
```

Using [WinGet](https://docs.microsoft.com/en-us/windows/package-manager/winget/):
```
winget upgrade git
```

### Windows (Windows Subsystem for Linux)

```
sudo add-apt-repository 'deb http://ppa.launchpad.net/git-core/ppa/ubuntu groovy main'
sudo apt update
sudo apt install git
```

### macOS (Built-in Git)

You can upgrade your version of macOS, as Big Sur has a recent version of Git (v2.30) available at `/usr/bin/git`. If you can't upgrade macOS, follow the instructions for Homebrew below.

### macOS (Homebrew)

```
brew install git  # If you don't have Git installed via Homebrew already.
brew upgrade git  # If you do.
```

### Linux (Debian derivatives, including Ubuntu)

```
sudo add-apt-repository ppa:git-core/ppa
sudo apt update
sudo apt install git
```
