For users of Nix git-branchless is also available as a [Nix
flake](https://nixos.wiki/wiki/Flakes).  Flakes are only available in Nix 2.4 or
newer and require the following experimental features to be set in the
`nix.conf`:

```
experimental-features = nix-command flakes
```

Afterwards the new Nix CLI commands can be used to launch a shell where
git-branchless is available using

```
nix shell github:arxanas/git-branchless
```

Users who like to be on the bleeding edge can add git-branchless to their flake
inputs and use the included overlay to add git-branchless to their profile.

```nix
{
  inputs.git-branchless.url = "github:arxanas/git-branchless";

  outputs = { self, nixpkgs, git-branchless, ... }:
    let
      system = "x86_64-linux";
      pkgs = import nixpkgs {
        inherit system;
        overlays = [ git-branchless.overlays.default ];
      };
    in {
      # flake outputs ...
      # pkgs.git-branchless refers to the GitHub version
    };
}
```
