* [Search the Wiki 🔎](https://github.com/arxanas/git-branchless/search?type=wikis)
* User guide
  * [Welcome](https://github.com/arxanas/git-branchless/wiki)
  * [Installation](https://github.com/arxanas/git-branchless/wiki/Installation)
    * [Git compatibility](https://github.com/arxanas/git-branchless/wiki/Git-compatibility)
    * [Nix flake](https://github.com/arxanas/git-branchless/wiki/Nix-flake)
    * [Uninstallation](https://github.com/arxanas/git-branchless/wiki/Uninstallation)
  * [Tutorial](https://github.com/arxanas/git-branchless/wiki/Tutorial)
  * Command overview
    * General:
      * [<code>git&nbsp;smartlog</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-smartlog)
      * [<code>git&nbsp;undo</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-undo)
    * Navigation:
      * [<code>git&nbsp;sw</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-sw)
      * [<code>git&nbsp;next/prev</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-next,-git-prev)
    * Committing:
      * [<code>git&nbsp;record</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-record)
      * [<code>git&nbsp;amend</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-amend)
      * [<code>git&nbsp;reword</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-reword)
    * Rebasing:
      * [<code>git&nbsp;move</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-move)
      * [<code>git&nbsp;restack</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-restack)
      * [<code>git&nbsp;hide/unhide</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-hide,-git-unhide)
    * Verification:
      * [<code>git&nbsp;test</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-test)
      * [<code>git&nbsp;query</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-query)
      * [<code>git&nbsp;branchless&nbsp;difftool</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-branchless-difftool)
    * Collaboration:
      * [<code>git&nbsp;sync</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-sync)
      * [<code>git&nbsp;submit</code>](https://github.com/arxanas/git-branchless/wiki/Command:-git-submit)
  * Workflows
    * [Stashing](https://github.com/arxanas/git-branchless/wiki/Workflow:-stashing)
    * [Divergent development](https://github.com/arxanas/git-branchless/wiki/Workflow:-divergent-development)
    * [Editing an old commit's message](https://github.com/arxanas/git-branchless/wiki/Workflow:-Editing-an-old-commit's-message)
    * [Editing an old commit's contents](https://github.com/arxanas/git-branchless/wiki/Workflow:-Editing-an-old-commit's-contents)
    * [Adding a commit to an earlier branch](https://github.com/arxanas/git-branchless/discussions/315#discussioncomment-2445315)
    * [Inserting a commit in between other commits](https://github.com/arxanas/git-branchless/discussions/478)
    * [Moving branches around](https://github.com/arxanas/git-branchless/discussions/402)
  * Advanced topics
    * [Garbage collection](https://github.com/arxanas/git-branchless/wiki/Advanced-topic:-garbage-collection)
  * Reference
    * [Concepts](https://github.com/arxanas/git-branchless/wiki/Concepts)
    * [Configuration](https://github.com/arxanas/git-branchless/wiki/Configuration)
    * [Commit visibility](https://github.com/arxanas/git-branchless/wiki/Command:-git-smartlog#which-commits-are-visible)
    * [Revsets](https://github.com/arxanas/git-branchless/wiki/Reference:-Revsets)
    * [Revset recipes](https://github.com/arxanas/git-branchless/discussions/496)
    * [Related tools](https://github.com/arxanas/git-branchless/wiki/Related-tools)
* Developer guide
  * [Onboarding offer](https://github.com/arxanas/git-branchless/wiki/Onboarding)
  * Development
    * [Architecture](https://github.com/arxanas/git-branchless/wiki/Architecture)
    * [Runbook](https://github.com/arxanas/git-branchless/wiki/Runbook)
    * [Coding](https://github.com/arxanas/git-branchless/wiki/Coding)
  * Reference
    * [Wiki style guide](https://github.com/arxanas/git-branchless/wiki/Wiki-style-guide)
    * [Design goals](https://github.com/arxanas/git-branchless/wiki/Design-goals)